
#include <DHT.h>
#include <DHT_U.h>

//int id= 55;
#include <SoftwareSerial.h>
SoftwareSerial sw(8, 9); // RX, TX

#define humidity_topic "/ESP/Humidity/33/"
#define temperature_topic "/ESP/Temperature/33/"
#define soil_topic "/ESP/Soil/33/"

#define DHTPIN 10     // Digital pin connected to the DHT sensor

#define DHTTYPE DHT11   // DHT 11

DHT dht(DHTPIN, DHTTYPE);

void setup() {
  Serial.begin(115200);
  Serial.println("Interfacfing arduino with nodemcu");
  sw.begin(115200);
  dht.begin();
}

void loop() {
  // Wait a few seconds between measurements.
  delay(2000);
  //Soil Moisture
 
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  int sensorValue = analogRead(A2);
  
  float h = dht.readHumidity();
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();
  // Read temperature as Fahrenheit (isFahrenheit = true)
  float f = dht.readTemperature(true);

  // Check if any reads failed and exit early (to try again).
  //if (isnan(h) || isnan(t) || isnan(f)) {
   // Serial.println(F("Failed to read from DHT sensor!"));
   // return;
  //}

  // Compute heat index in Fahrenheit (the default)
  float hif = dht.computeHeatIndex(f, h);
  // Compute heat index in Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);
  
  //TEMP INFO
  Serial.print(F("Humidity: "));
  Serial.println(h);
   //sw.print("{\"Humidity\":");
   
   sw.println(humidity_topic); // Humidity topic here
   sw.print("=");
   sw.println(h);
   //sw.println("}");
   
  //Arduino HUMIDITY
  Serial.print(("Temperature: "));
  Serial.println(t);

  //sw.print("{\"Temperature\":"); //Celcius
  sw.print(temperature_topic); //Temperature topic here
  sw.print("=");
  sw.println(t);//sensor id
  //sw.println("}");
  
  //Soil Sensor Data
 Serial.print(("Soil:"));
 Serial.println(sensorValue);
 sw.print(soil_topic);
 sw.print("=");
 sw.println(sensorValue);
}